<template>
  <div class="normal-bank-transfer-withdrawal">
    <div class="space-y-2 px-6 ui-radio-bank">
      <div
        v-if="bankTransferWithdrawalTextInfo?.Text.length > 0"
        class="p-4 text-sm rounded bg-background5 --text4 font-normal mb-4"
        v-html="bankTransferWithdrawalTextInfo?.Text"
      ></div>
      <h5 :class=" theme === 'peru_green' ? 'text-color' : '--text4' ">{{ $t("bank") }}</h5>
      <div class="w-full flex flex-row flex-wrap gap-3">
        <ui-radio-group
          v-model="selectedBank"
          group-name="peru-withdrawal-select-bank-name"
          class="flex flex-row flex-wrap gap-3 py-2 withdrawal-peru-select-bank"
        >
          <ui-radio-button
            v-for="bank in bankRadios"
            :key="bank.PlayerBankName"
            :label="bank.PlayerBankName"
            :value="bank.PlayerBankName"
            active-class="selected"
          >
            <ui-check-button
              v-if="!bank.BankLogo || bank.BankLogo == undefined"
              variant="ICON_AND_TEXT"
              :text="bank.PlayerBankName"
            />
            <ui-check-button
              v-else
              style="--height: 3rem"
              :img="getImagePathBankLogo(bank.BankLogo)"
            />
          </ui-radio-button>
        </ui-radio-group>
      </div>
    </div>
    <div class="p-6">
      <el-form
        ref="bankTransferWithdrawalFormRef"
        label-width="210px"
        :model="bankTransferWithdrawalFormData"
        :rules="bankTransferWithdrawalRules"
        label-position="left"
        :validate-on-rule-change="false"
      >
        <el-form-item
          v-if="isBankNameEnabled || selectedBank === 'Other'"
          :label="$t('bank_name')"
          prop="customizeBankName"
        >
          <el-input
            v-model="bankTransferWithdrawalFormData.customizeBankName"
          />
        </el-form-item>
        <el-form-item
          v-show="branchNameSetting"
          :label="$t('BranchName')"
          prop="branchName"
        >
          <el-input v-model="bankTransferWithdrawalFormData.branchName" />
        </el-form-item>
        <el-form-item
          v-if="bankAccountNameSetting"
          :label="$t('bank_account_name')" 
          prop="bankAccountName"
        >
          <el-input
            v-model="bankTransferWithdrawalFormData.bankAccountName"
            :disabled="!isFirstTimeDeposit && selectedBank !== 'Other' && !isFirstTimeBankAccountNameEmpty"
          />
        </el-form-item>
        <el-form-item
          v-if="bankAccountNumberSetting"
          :label="$t('bank_account_number')"
          prop="bankAccountNumber"
        >
          <el-input
            v-model="bankTransferWithdrawalFormData.bankAccountNumber"
            :disabled="!isFirstTimeDeposit && selectedBank !== 'Other' && !isFirstTimeBankAccountNumberEmpty"
            oninput="this.value = this.value.replace(/[^0-9]/g, '')"
          />
        </el-form-item>
        <el-form-item
          v-show="cpfNumberSetting"
          :label="$t('CPF Number')"
          prop="cpfNumber"
        >
          <el-input 
            maxlength="11" 
            v-model="bankTransferWithdrawalFormData.cpfNumber" id="withdrawalCPFNumber" 
            @input="onInputValue($event, bankTransferWithdrawalFormData, 'cpfNumber')"
          />
        </el-form-item>
        <el-form-item
        v-if="bsbSetting"
        :label="$t('BSB')"
        prop="bsb"
      >
        <el-input
          maxlength="6"
          v-model="bankTransferWithdrawalFormData.bsb" id="withdrawalBSB" 
          @input="onInputValue($event, bankTransferWithdrawalFormData, 'bsb')"
        />
      </el-form-item>
      <el-form-item
        v-if="payIdSetting"
        :label="$t('PayID')"
        prop="payId"
      >
        <el-input 
          v-model="bankTransferWithdrawalFormData.payId" id="withdrawalPayId"
        />
      </el-form-item>
        <el-form-item :label="$t('balance')" class="--text4">
          {{ playerCreditBalance }}
        </el-form-item>
        <template v-if="isWithdrawalLimitEnabled">
          <el-form-item v-if="isAllowEligibleWithdrawal" :label="$t('eligible_withdrawal')" class="--text4">
            <div class="fc-primary font-bold">{{ eligibleWithdrawal }}</div>
          </el-form-item>
          <el-form-item
            prop="withdrawalLimit"
            :label="$t('remaining_rollover')"
            class="--text4"
          >
            {{ remainingRollover }}
          </el-form-item>
        </template>
        <el-form-item :label="$t('amount')" prop="amountValue">
          <el-input
            v-model="bankTransferWithdrawalFormData.amountValue"
            oninput="this.value = this.value.replace(/[^.0-9]/g, '')"
            :placeholder="amountPlaceholder"
          >
            <template v-if="checkedCurrency" #append>
              <span>000</span>
            </template>
          </el-input>
          <span v-if="checkedCurrency" class="order-1 text-xs fc-hint mt-3">{{
            $t(
              `withdrawal_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
            )
          }}</span>
        </el-form-item>
        <el-form-item
          v-if="isPaymentPasswordEnable"
          :label="$t('payment_password')"
          prop="paymentPasswordValue"
        >
          <el-input
            v-model="bankTransferWithdrawalFormData.paymentPasswordValue"
            type="password"
          />
        </el-form-item>
        <div class="flex justify-center mb-4">
          <el-button
            type="primary"
            :disabled="isWithdrawProcessing"
            round
            class="w-[120px] responsive-height"
            @click="submitWithdrawalBankTransfer(bankTransferWithdrawalFormRef)"
          >
            {{ $t("submit") }}
          </el-button>
        </div>
      </el-form>
    </div>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType, toRefs } from "vue";
import { IGetTransactionBankListResponse } from "@/models/getTransactionBankListResponse";
import { IGetPaymentGatewayBanksResponse } from "@/models/getPaymentGatewayBanksRespone";
import { ProfileDto } from "@/models/getProfileResponse";

export default defineComponent({
  name: "NormalBankTransferWithdrawal",
  props: {
    normalBanks: {
      type: Object as PropType<IGetTransactionBankListResponse>,
      required: true,
    },
    paymentBanks: {
      type: Object as PropType<IGetPaymentGatewayBanksResponse>,
      required: true,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
    },
    isPaymentPasswordEnable: {
      type: Boolean,
      default: false,
    },
    isWithdrawalLimitEnabled: {
      type: Boolean,
      default: false,
    },
  },
  setup(props) {
    const {
      normalBanks,
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled,
    } = toRefs(props);
    const {
      isFirstTimeDeposit,
      playerCreditBalance,
      withdrawalMin,
      withdrawalMax,
      bankRadios,
      selectedBank,
      branchNameSetting,
      isBankNameEnabled,
      submitWithdrawalBankTransfer,
      bankTransferWithdrawalFormRef,
      bankTransferWithdrawalFormData,
      bankTransferWithdrawalRules,
      isWithdrawProcessing,
      checkedCurrency,
      remainingRollover,
      eligibleWithdrawal,
      amountPlaceholder,
      bankTransferWithdrawalTextInfo,
      cpfNumberSetting,
      bsbSetting,
      payIdSetting,
      bankAccountNumberSetting,
      bankAccountNameSetting,
      isFirstTimeBankAccountNameEmpty,
      isFirstTimeBankAccountNumberEmpty
    } = useNormalBankTransferWithdrawal(
      normalBanks,
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled
    );
    const { getAssetImage, allowCompany, isAllowEligibleWithdrawal } = commonHelper;
    const { themeColor } = themePropertyHelper;
    const  theme  = themeColor.value.Text ;
    const { getImagePathBankLogo } = depositBankImageHelper;
    return {
      isFirstTimeDeposit,
      playerCreditBalance,
      withdrawalMin,
      withdrawalMax,
      bankRadios,
      selectedBank,
      branchNameSetting,
      isBankNameEnabled,
      submitWithdrawalBankTransfer,
      bankTransferWithdrawalFormRef,
      bankTransferWithdrawalFormData,
      bankTransferWithdrawalRules,
      isWithdrawProcessing,
      checkedCurrency,
      remainingRollover,
      eligibleWithdrawal,
      amountPlaceholder,
      bankTransferWithdrawalTextInfo,
      getAssetImage,
      theme,
      getImagePathBankLogo,
      allowCompany,
      cpfNumberSetting,
      isAllowEligibleWithdrawal,
      bsbSetting,
      payIdSetting,
      bankAccountNumberSetting,
      bankAccountNameSetting,
      isFirstTimeBankAccountNameEmpty,
      isFirstTimeBankAccountNumberEmpty
    };
  },
});
</script>
<style scoped>
:deep(.ui-radio-group .check-btn__img img) {
  max-height: 32px;
}
:deep(.ui-radio-group .check-btn__img) {
  max-width: max-content;
  display: block;
}
:deep(.ui-radio-button .check-btn__content) {
  padding-right: 16px;
}
:deep(.ui-radio-button.selected .check-btn__content) {
  padding-right: 40px;
}
@media screen and (max-width: 639px) {
  :deep(
      .ui-radio-group.withdrawal-peru-select-bank
        .ui-radio-button.selected
        .check-btn__text
    ) {
    padding-right: 16px;
  }
  :deep(
      .ui-radio-group.withdrawal-peru-select-bank
        .ui-radio-button.selected
        .check-btn__img
    ) {
    padding-right: 16px;
  }
}
</style>
<style lang="scss">
.normal-bank-transfer-withdrawal {
  @media screen and (min-width: 640px) and (max-width: 767px) {
    .el-form-item {
      display: block;
    }
    // .select-bank {
    //   display: none !important;
    // }
  }
  @media screen and (max-width: 639px) {
    .el-form-item {
      display: block;
    }
    // .ui-radio-bank {
    //   display: none;
    // }
    // .select-bank {
    //   display: block;
    // }
  }
}
.withdrawal-req {
  @media screen and (max-width: 471px) {
    flex-direction: column;
  }
}
.text-color{
  color: var(--primary);
}
.responsive-height{
  @media screen and (min-width: 640px) {
   height: 32px;
  } 
  @media screen and (max-width: 640px) {
   height: 40px;
  } 
}
</style>
